import java.io.*;
import java.net.*;
import java.util.*;

import com.sun.ejte.ccl.reporter.SimpleReporterAdapter;

public class WebTest {

    private static SimpleReporterAdapter stat
        = new SimpleReporterAdapter("appserver-sqe");
    private static String TEST_NAME = "test";

    private String testSuiteID;
    private String host;
    private String port;
    private String contextRoot;


    public WebTest(String[] args) {
        testSuiteID = args[0];
        host = args[1];
        port = args[2];
        contextRoot = args[3];
        TEST_NAME = testSuiteID;
    }
    
    public static void main(String[] args) {
        stat.addDescription("Bean Managed Concurrance for Singleton");
        WebTest webTest = new WebTest(args);
        webTest.doTest();
        stat.printSummary(TEST_NAME);
    }

    public void doTest() {     
        try { 
            testConcurrent();
            test("check");
        } catch (Exception ex) {
	    stat.addStatus(TEST_NAME, stat.FAIL);
            ex.printStackTrace();
        }
    }

    public void testConcurrent(){
      try{
  
	System.out.println("This is to test concurrent Singleton access ");
     
	Thread t1 = new Thread(){ 

	  public void run() {
	    System.out.println("Thread 1 doing Singleton access ");
	    try { 
             test("access");
	    } catch (Exception ex) {
	      ex.printStackTrace();
	    }
	  }
	};
	Thread t2 = new Thread() {
	  public void run() {
	    System.out.println("Thread 2 doing Singleton access ");
	    try { 
             test("access");
	    } catch (Exception ex) {
	      ex.printStackTrace();
	    }
	  }
	};
	Thread t3 = new Thread() {
	  public void run() {
	    System.out.println("Thread 3 doing Singleton access ");
	    try { 
             test("access");
	    } catch (Exception ex) {
	      ex.printStackTrace();
	    }
	  }
	};    

	t1.start();
	t2.start();
	t3.start();

	System.out.println("after thread started");
	t1.join();
	t2.join();
	t3.join();
	System.out.println("done-concurrentSingleton");
      } catch (Exception ex) {
	ex.printStackTrace();
      }finally{
	//System.exit(0);
      }

    }

    private void test(String testcase) throws Exception  {
        String EXPECTED_RESPONSE = "Test:Pass";
        String TEST_CASE = TEST_NAME + testcase;
        String url = "http://" + host + ":" + port + contextRoot +  
	  "/test?tc="+testcase;

        System.out.println("url="+url);

        HttpURLConnection conn = (HttpURLConnection)
            (new URL(url)).openConnection();
        int code = conn.getResponseCode();
        if (code != 200) {
            System.err.println("Unexpected return code: " + code);
            stat.addStatus(TEST_CASE, stat.FAIL);
        } else {
            InputStream is = conn.getInputStream();
            BufferedReader input = new BufferedReader(new InputStreamReader(is));
	    String line = null;
	    while ((line = input.readLine()) != null) {
	      if (line.contains(EXPECTED_RESPONSE)) {
		stat.addStatus(TEST_CASE, stat.PASS);
		break;
	      }
	    }
	    
	    if (line == null) {
	      System.out.println("Unable to find " + EXPECTED_RESPONSE +
				  " in the response");
	    }
	    stat.addStatus(TEST_CASE, stat.FAIL);
        }    
    }


}


