package ejb31.war.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.ArrayList;

import javax.ejb.EJB;

public class BMCServlet extends HttpServlet {
   @EJB
   BMCSingleton bmcs;

   @EJB  
   private DateSingleton  ds;

   private Long  sleepTime = 10000L;

   protected void processRequest(HttpServletRequest request, 
				 HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/plain");
        PrintWriter pw = response.getWriter();
        try {
            pw.println("BMCServlet");  
            pw.println("ContextPath: " + request.getContextPath ());
            String testcase = request.getParameter("tc");
            pw.println("testcase = " + testcase);
            if (testcase != null) {

	      if ("access".equals(testcase)){

		System.out.println("EntryExitTime: "+ bmcs.getEntryExitTime(sleepTime));

		pw.println("Test:Pass");
	      } else if ("check".equals(testcase)){
		pw.println("firstEntryTime: " + ds.getFirstEntryTime());
		pw.println("lastExitTime: " + ds.getLastExitTime());
		pw.println("Test:Pass");
	      } else {
		pw.println("No such testcase");
	      }
	    }
        } finally { 
            pw.close();
        }
    } 


    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
