package ejb31.war.servlet;

import java.util.Date;
import java.util.ArrayList;
import javax.ejb.Singleton;
import javax.annotation.PostConstruct;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;

@Singleton
@TransactionAttribute(TransactionAttributeType.NOT_SUPPORTED)
public class DateSingleton {

  private ArrayList<Date> dateRecord;
  private Date firstEntryTime;
  private Date lastExitTime;

  @PostConstruct
  public void afterConstruct() {
    System.out.println("------------------------------------");
    System.out.println("---PostConstruct in DateSingleton---");
    System.out.println("------------------------------------");
    dateRecord = new ArrayList<Date>();
  }


  public void addRecord(Date d) {
    dateRecord.add(d);
  }

  public Date getFirstEntryTime() {
    if (dateRecord.isEmpty())
      return null;
    else
    return dateRecord.get(0);
  }

  public Date getLastExitTime() {
    if (dateRecord.isEmpty())
      return null;
    else
      return dateRecord.get(dateRecord.size()-1);
  }
}
